(function(){
  if(typeof document === 'undefined' || !document)
    return;

  const domain = document.defaultView.location.hostname;
  const search = ['°°'];
  const domain_parts = origin.split('.');
  for(let i=1; i<domain_parts.length; i++)
    search.push(['°°',...domain_parts.slice(-i)].join('.'));
  {
    let x = [...domain_parts];
    x[0] = '°';
    search.push(x.join('.'));
  }
  search.push(domain);

  function inject(){
    for(let entry of search){
      const js = chrome.runtime.getURL(`content/${entry}.js`);
      const css = chrome.runtime.getURL(`content/${entry}.css`);
      const script = document.createElement("script");
      const link = document.createElement("link");
      link.rel = 'stylesheet';
      link.type = 'text/css';
      link.href = css;
      script.type = 'text/javascript';
      script.src = js;
      document.head.insertBefore(link  , document.head.firstChild);
      document.head.insertBefore(script, link);
    }
    setTimeout(()=>{if(document.documentElement)document.documentElement.style.display='';},100);
  }

  {
    let head;
    let html;
    const newhead = ()=>{
      if(head == document.head)
        return;
      head = document.head;
      if(head)
        inject();
    };
    const observer = new MutationObserver(newhead);
    const newdoc = ()=>{
      if(html == document.documentElement)
        return;
      html = document.documentElement;
      observer.disconnect();
      if(document.documentElement){
        document.documentElement.style.display = 'none';
        observer.observe(document.documentElement, { childList: true, subtree: false });
        newhead();
        setTimeout(()=>{if(document.documentElement)document.documentElement.style.display='';},200);
      }
    };
    newdoc();
    (new MutationObserver(newdoc)).observe(document, { childList: true, subtree: false });
  }
})();
